from __future__ import absolute_import
import numba
import re
import unittest
from accelerate import config

NUMBA_VERSION_REQ = (0, 22, 1)

def check_numba_version():
    m = re.match(r"(\d+)\.(\d+)\.(\d+).*", numba.__version__)
    if m is None or tuple(map(int, m.groups())) < NUMBA_VERSION_REQ:
        import warnings
        warnings.showwarning(
            "Numba version too old; expecting %d.%d.%d" % NUMBA_VERSION_REQ,
            ImportWarning, __name__, 1)

check_numba_version()

def load_tests(loader, tests, pattern):
    from .tests import test_cases

    suite = unittest.TestSuite()
    for test_class in test_cases:
        tests = loader.loadTestsFromTestCase(test_class)
        suite.addTests(tests)
    return suite

from ._version import get_versions
__version__ = get_versions()['version']
del get_versions
