typedef
struct _MKL_Complex8 {
    float real;
    float imag;
} MKL_Complex8;




typedef
struct _MKL_Complex16 {
    double real;
    double imag;
} MKL_Complex16;



typedef
struct {
    int MajorVersion;
    int MinorVersion;
    int UpdateVersion;
    char * ProductStatus;
    char * Build;
    char * Processor;
    char * Platform;
} MKLVersion;
typedef struct _DefVmlErrorContext
{
    int iCode;
    int iIndex;
    double dbA1;
    double dbA2;
    double dbR1;
    double dbR2;
    char cFuncName[64];
    int iFuncNameLen;
    double dbA1Im;
    double dbA2Im;
    double dbR1Im;
    double dbR2Im;
} DefVmlErrorContext;




typedef int (*VMLErrorCallBack) (DefVmlErrorContext* pdefVmlErrorContext);
extern void VSABS_ (const int *n, const float a[], float r[]);
extern void VDABS_ (const int *n, const double a[], double r[]);
extern void vsabs_ (const int *n, const float a[], float r[]);
extern void vdabs_ (const int *n, const double a[], double r[]);
extern void vsAbs (const int n, const float a[], float r[]);
extern void vdAbs (const int n, const double a[], double r[]);

extern void VMSABS_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDABS_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsabs_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdabs_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAbs (const int n, const float a[], float r[], long long int mode);
extern void vmdAbs (const int n, const double a[], double r[], long long int mode);


extern void VCABS_ (const int *n, const MKL_Complex8 a[], float r[]);
extern void VZABS_ (const int *n, const MKL_Complex16 a[], double r[]);
extern void vcabs_ (const int *n, const MKL_Complex8 a[], float r[]);
extern void vzabs_ (const int *n, const MKL_Complex16 a[], double r[]);
extern void vcAbs (const int n, const MKL_Complex8 a[], float r[]);
extern void vzAbs (const int n, const MKL_Complex16 a[], double r[]);

extern void VMCABS_ (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void VMZABS_ (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void vmcabs_ (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void vmzabs_ (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void vmcAbs (const int n, const MKL_Complex8 a[], float r[], long long int mode);
extern void vmzAbs (const int n, const MKL_Complex16 a[], double r[], long long int mode);


extern void VCARG_ (const int *n, const MKL_Complex8 a[], float r[]);
extern void VZARG_ (const int *n, const MKL_Complex16 a[], double r[]);
extern void vcarg_ (const int *n, const MKL_Complex8 a[], float r[]);
extern void vzarg_ (const int *n, const MKL_Complex16 a[], double r[]);
extern void vcArg (const int n, const MKL_Complex8 a[], float r[]);
extern void vzArg (const int n, const MKL_Complex16 a[], double r[]);

extern void VMCARG_ (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void VMZARG_ (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void vmcarg_ (const int *n, const MKL_Complex8 a[], float r[], long long int *mode);
extern void vmzarg_ (const int *n, const MKL_Complex16 a[], double r[], long long int *mode);
extern void vmcArg (const int n, const MKL_Complex8 a[], float r[], long long int mode);
extern void vmzArg (const int n, const MKL_Complex16 a[], double r[], long long int mode);


extern void VSADD_ (const int *n, const float a[], const float b[], float r[]);
extern void VDADD_ (const int *n, const double a[], const double b[], double r[]);
extern void vsadd_ (const int *n, const float a[], const float b[], float r[]);
extern void vdadd_ (const int *n, const double a[], const double b[], double r[]);
extern void vsAdd (const int n, const float a[], const float b[], float r[]);
extern void vdAdd (const int n, const double a[], const double b[], double r[]);

extern void VMSADD_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDADD_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsadd_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdadd_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsAdd (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdAdd (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VCADD_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZADD_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcadd_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzadd_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcAdd (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzAdd (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCADD_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZADD_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcadd_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzadd_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcAdd (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzAdd (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VSSUB_ (const int *n, const float a[], const float b[], float r[]);
extern void VDSUB_ (const int *n, const double a[], const double b[], double r[]);
extern void vssub_ (const int *n, const float a[], const float b[], float r[]);
extern void vdsub_ (const int *n, const double a[], const double b[], double r[]);
extern void vsSub (const int n, const float a[], const float b[], float r[]);
extern void vdSub (const int n, const double a[], const double b[], double r[]);

extern void VMSSUB_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDSUB_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmssub_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdsub_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsSub (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdSub (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VCSUB_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZSUB_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcsub_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzsub_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcSub (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzSub (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCSUB_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZSUB_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcsub_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzsub_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcSub (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzSub (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VSINV_ (const int *n, const float a[], float r[]);
extern void VDINV_ (const int *n, const double a[], double r[]);
extern void vsinv_ (const int *n, const float a[], float r[]);
extern void vdinv_ (const int *n, const double a[], double r[]);
extern void vsInv (const int n, const float a[], float r[]);
extern void vdInv (const int n, const double a[], double r[]);

extern void VMSINV_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDINV_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsinv_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdinv_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsInv (const int n, const float a[], float r[], long long int mode);
extern void vmdInv (const int n, const double a[], double r[], long long int mode);


extern void VSSQRT_ (const int *n, const float a[], float r[]);
extern void VDSQRT_ (const int *n, const double a[], double r[]);
extern void vssqrt_ (const int *n, const float a[], float r[]);
extern void vdsqrt_ (const int *n, const double a[], double r[]);
extern void vsSqrt (const int n, const float a[], float r[]);
extern void vdSqrt (const int n, const double a[], double r[]);

extern void VMSSQRT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDSQRT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmssqrt_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdsqrt_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsSqrt (const int n, const float a[], float r[], long long int mode);
extern void vmdSqrt (const int n, const double a[], double r[], long long int mode);


extern void VCSQRT_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZSQRT_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcsqrt_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzsqrt_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcSqrt (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzSqrt (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCSQRT_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZSQRT_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcsqrt_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzsqrt_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcSqrt (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzSqrt (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSINVSQRT_ (const int *n, const float a[], float r[]);
extern void VDINVSQRT_ (const int *n, const double a[], double r[]);
extern void vsinvsqrt_ (const int *n, const float a[], float r[]);
extern void vdinvsqrt_ (const int *n, const double a[], double r[]);
extern void vsInvSqrt (const int n, const float a[], float r[]);
extern void vdInvSqrt (const int n, const double a[], double r[]);

extern void VMSINVSQRT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDINVSQRT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsinvsqrt_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdinvsqrt_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsInvSqrt (const int n, const float a[], float r[], long long int mode);
extern void vmdInvSqrt (const int n, const double a[], double r[], long long int mode);


extern void VSCBRT_ (const int *n, const float a[], float r[]);
extern void VDCBRT_ (const int *n, const double a[], double r[]);
extern void vscbrt_ (const int *n, const float a[], float r[]);
extern void vdcbrt_ (const int *n, const double a[], double r[]);
extern void vsCbrt (const int n, const float a[], float r[]);
extern void vdCbrt (const int n, const double a[], double r[]);

extern void VMSCBRT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCBRT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmscbrt_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdcbrt_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCbrt (const int n, const float a[], float r[], long long int mode);
extern void vmdCbrt (const int n, const double a[], double r[], long long int mode);


extern void VSINVCBRT_ (const int *n, const float a[], float r[]);
extern void VDINVCBRT_ (const int *n, const double a[], double r[]);
extern void vsinvcbrt_ (const int *n, const float a[], float r[]);
extern void vdinvcbrt_ (const int *n, const double a[], double r[]);
extern void vsInvCbrt (const int n, const float a[], float r[]);
extern void vdInvCbrt (const int n, const double a[], double r[]);

extern void VMSINVCBRT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDINVCBRT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsinvcbrt_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdinvcbrt_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsInvCbrt (const int n, const float a[], float r[], long long int mode);
extern void vmdInvCbrt (const int n, const double a[], double r[], long long int mode);


extern void VSSQR_ (const int *n, const float a[], float r[]);
extern void VDSQR_ (const int *n, const double a[], double r[]);
extern void vssqr_ (const int *n, const float a[], float r[]);
extern void vdsqr_ (const int *n, const double a[], double r[]);
extern void vsSqr (const int n, const float a[], float r[]);
extern void vdSqr (const int n, const double a[], double r[]);

extern void VMSSQR_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDSQR_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmssqr_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdsqr_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsSqr (const int n, const float a[], float r[], long long int mode);
extern void vmdSqr (const int n, const double a[], double r[], long long int mode);


extern void VSEXP_ (const int *n, const float a[], float r[]);
extern void VDEXP_ (const int *n, const double a[], double r[]);
extern void vsexp_ (const int *n, const float a[], float r[]);
extern void vdexp_ (const int *n, const double a[], double r[]);
extern void vsExp (const int n, const float a[], float r[]);
extern void vdExp (const int n, const double a[], double r[]);

extern void VMSEXP_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDEXP_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsexp_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdexp_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsExp (const int n, const float a[], float r[], long long int mode);
extern void vmdExp (const int n, const double a[], double r[], long long int mode);


extern void VSEXPM1_ (const int *n, const float a[], float r[]);
extern void VDEXPM1_ (const int *n, const double a[], double r[]);
extern void vsexpm1_ (const int *n, const float a[], float r[]);
extern void vdexpm1_ (const int *n, const double a[], double r[]);
extern void vsExpm1 (const int n, const float a[], float r[]);
extern void vdExpm1 (const int n, const double a[], double r[]);

extern void VMSEXPM1_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDEXPM1_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsexpm1_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdexpm1_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsExpm1 (const int n, const float a[], float r[], long long int mode);
extern void vmdExpm1 (const int n, const double a[], double r[], long long int mode);


extern void VCEXP_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZEXP_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcexp_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzexp_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcExp (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzExp (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCEXP_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZEXP_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcexp_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzexp_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcExp (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzExp (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSLN_ (const int *n, const float a[], float r[]);
extern void VDLN_ (const int *n, const double a[], double r[]);
extern void vsln_ (const int *n, const float a[], float r[]);
extern void vdln_ (const int *n, const double a[], double r[]);
extern void vsLn (const int n, const float a[], float r[]);
extern void vdLn (const int n, const double a[], double r[]);

extern void VMSLN_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDLN_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsln_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdln_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsLn (const int n, const float a[], float r[], long long int mode);
extern void vmdLn (const int n, const double a[], double r[], long long int mode);


extern void VCLN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZLN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcln_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzln_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcLn (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzLn (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCLN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZLN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcln_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzln_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcLn (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzLn (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSLOG10_ (const int *n, const float a[], float r[]);
extern void VDLOG10_ (const int *n, const double a[], double r[]);
extern void vslog10_ (const int *n, const float a[], float r[]);
extern void vdlog10_ (const int *n, const double a[], double r[]);
extern void vsLog10 (const int n, const float a[], float r[]);
extern void vdLog10 (const int n, const double a[], double r[]);

extern void VMSLOG10_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDLOG10_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmslog10_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdlog10_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsLog10 (const int n, const float a[], float r[], long long int mode);
extern void vmdLog10 (const int n, const double a[], double r[], long long int mode);


extern void VCLOG10_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZLOG10_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vclog10_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzlog10_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcLog10 (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzLog10 (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCLOG10_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZLOG10_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmclog10_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzlog10_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcLog10 (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzLog10 (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSLOG1P_ (const int *n, const float a[], float r[]);
extern void VDLOG1P_ (const int *n, const double a[], double r[]);
extern void vslog1p_ (const int *n, const float a[], float r[]);
extern void vdlog1p_ (const int *n, const double a[], double r[]);
extern void vsLog1p (const int n, const float a[], float r[]);
extern void vdLog1p (const int n, const double a[], double r[]);

extern void VMSLOG1P_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDLOG1P_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmslog1p_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdlog1p_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsLog1p (const int n, const float a[], float r[], long long int mode);
extern void vmdLog1p (const int n, const double a[], double r[], long long int mode);


extern void VSCOS_ (const int *n, const float a[], float r[]);
extern void VDCOS_ (const int *n, const double a[], double r[]);
extern void vscos_ (const int *n, const float a[], float r[]);
extern void vdcos_ (const int *n, const double a[], double r[]);
extern void vsCos (const int n, const float a[], float r[]);
extern void vdCos (const int n, const double a[], double r[]);

extern void VMSCOS_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCOS_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmscos_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdcos_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCos (const int n, const float a[], float r[], long long int mode);
extern void vmdCos (const int n, const double a[], double r[], long long int mode);


extern void VCCOS_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZCOS_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vccos_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzcos_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcCos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzCos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCCOS_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZCOS_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmccos_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzcos_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcCos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzCos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSSIN_ (const int *n, const float a[], float r[]);
extern void VDSIN_ (const int *n, const double a[], double r[]);
extern void vssin_ (const int *n, const float a[], float r[]);
extern void vdsin_ (const int *n, const double a[], double r[]);
extern void vsSin (const int n, const float a[], float r[]);
extern void vdSin (const int n, const double a[], double r[]);

extern void VMSSIN_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDSIN_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmssin_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdsin_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsSin (const int n, const float a[], float r[], long long int mode);
extern void vmdSin (const int n, const double a[], double r[], long long int mode);


extern void VCSIN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZSIN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcsin_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzsin_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcSin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzSin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCSIN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZSIN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcsin_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzsin_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcSin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzSin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSTAN_ (const int *n, const float a[], float r[]);
extern void VDTAN_ (const int *n, const double a[], double r[]);
extern void vstan_ (const int *n, const float a[], float r[]);
extern void vdtan_ (const int *n, const double a[], double r[]);
extern void vsTan (const int n, const float a[], float r[]);
extern void vdTan (const int n, const double a[], double r[]);

extern void VMSTAN_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDTAN_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmstan_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdtan_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsTan (const int n, const float a[], float r[], long long int mode);
extern void vmdTan (const int n, const double a[], double r[], long long int mode);


extern void VCTAN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZTAN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vctan_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vztan_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcTan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzTan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCTAN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZTAN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmctan_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmztan_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcTan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzTan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSCOSH_ (const int *n, const float a[], float r[]);
extern void VDCOSH_ (const int *n, const double a[], double r[]);
extern void vscosh_ (const int *n, const float a[], float r[]);
extern void vdcosh_ (const int *n, const double a[], double r[]);
extern void vsCosh (const int n, const float a[], float r[]);
extern void vdCosh (const int n, const double a[], double r[]);

extern void VMSCOSH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCOSH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmscosh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdcosh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCosh (const int n, const float a[], float r[], long long int mode);
extern void vmdCosh (const int n, const double a[], double r[], long long int mode);


extern void VCCOSH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZCOSH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vccosh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzcosh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcCosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzCosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCCOSH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZCOSH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmccosh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzcosh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcCosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzCosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSSINH_ (const int *n, const float a[], float r[]);
extern void VDSINH_ (const int *n, const double a[], double r[]);
extern void vssinh_ (const int *n, const float a[], float r[]);
extern void vdsinh_ (const int *n, const double a[], double r[]);
extern void vsSinh (const int n, const float a[], float r[]);
extern void vdSinh (const int n, const double a[], double r[]);

extern void VMSSINH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDSINH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmssinh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdsinh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsSinh (const int n, const float a[], float r[], long long int mode);
extern void vmdSinh (const int n, const double a[], double r[], long long int mode);


extern void VCSINH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZSINH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcsinh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzsinh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcSinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzSinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCSINH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZSINH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcsinh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzsinh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcSinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzSinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSTANH_ (const int *n, const float a[], float r[]);
extern void VDTANH_ (const int *n, const double a[], double r[]);
extern void vstanh_ (const int *n, const float a[], float r[]);
extern void vdtanh_ (const int *n, const double a[], double r[]);
extern void vsTanh (const int n, const float a[], float r[]);
extern void vdTanh (const int n, const double a[], double r[]);

extern void VMSTANH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDTANH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmstanh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdtanh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsTanh (const int n, const float a[], float r[], long long int mode);
extern void vmdTanh (const int n, const double a[], double r[], long long int mode);


extern void VCTANH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZTANH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vctanh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vztanh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcTanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzTanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCTANH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZTANH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmctanh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmztanh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcTanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzTanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSACOS_ (const int *n, const float a[], float r[]);
extern void VDACOS_ (const int *n, const double a[], double r[]);
extern void vsacos_ (const int *n, const float a[], float r[]);
extern void vdacos_ (const int *n, const double a[], double r[]);
extern void vsAcos (const int n, const float a[], float r[]);
extern void vdAcos (const int n, const double a[], double r[]);

extern void VMSACOS_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDACOS_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsacos_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdacos_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAcos (const int n, const float a[], float r[], long long int mode);
extern void vmdAcos (const int n, const double a[], double r[], long long int mode);


extern void VCACOS_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZACOS_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcacos_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzacos_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAcos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAcos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCACOS_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZACOS_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcacos_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzacos_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAcos (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAcos (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSASIN_ (const int *n, const float a[], float r[]);
extern void VDASIN_ (const int *n, const double a[], double r[]);
extern void vsasin_ (const int *n, const float a[], float r[]);
extern void vdasin_ (const int *n, const double a[], double r[]);
extern void vsAsin (const int n, const float a[], float r[]);
extern void vdAsin (const int n, const double a[], double r[]);

extern void VMSASIN_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDASIN_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsasin_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdasin_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAsin (const int n, const float a[], float r[], long long int mode);
extern void vmdAsin (const int n, const double a[], double r[], long long int mode);


extern void VCASIN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZASIN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcasin_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzasin_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAsin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAsin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCASIN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZASIN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcasin_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzasin_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAsin (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAsin (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSATAN_ (const int *n, const float a[], float r[]);
extern void VDATAN_ (const int *n, const double a[], double r[]);
extern void vsatan_ (const int *n, const float a[], float r[]);
extern void vdatan_ (const int *n, const double a[], double r[]);
extern void vsAtan (const int n, const float a[], float r[]);
extern void vdAtan (const int n, const double a[], double r[]);

extern void VMSATAN_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDATAN_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsatan_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdatan_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAtan (const int n, const float a[], float r[], long long int mode);
extern void vmdAtan (const int n, const double a[], double r[], long long int mode);


extern void VCATAN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZATAN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcatan_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzatan_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAtan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAtan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCATAN_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZATAN_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcatan_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzatan_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAtan (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAtan (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSACOSH_ (const int *n, const float a[], float r[]);
extern void VDACOSH_ (const int *n, const double a[], double r[]);
extern void vsacosh_ (const int *n, const float a[], float r[]);
extern void vdacosh_ (const int *n, const double a[], double r[]);
extern void vsAcosh (const int n, const float a[], float r[]);
extern void vdAcosh (const int n, const double a[], double r[]);

extern void VMSACOSH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDACOSH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsacosh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdacosh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAcosh (const int n, const float a[], float r[], long long int mode);
extern void vmdAcosh (const int n, const double a[], double r[], long long int mode);


extern void VCACOSH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZACOSH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcacosh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzacosh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAcosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAcosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCACOSH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZACOSH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcacosh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzacosh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAcosh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAcosh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSASINH_ (const int *n, const float a[], float r[]);
extern void VDASINH_ (const int *n, const double a[], double r[]);
extern void vsasinh_ (const int *n, const float a[], float r[]);
extern void vdasinh_ (const int *n, const double a[], double r[]);
extern void vsAsinh (const int n, const float a[], float r[]);
extern void vdAsinh (const int n, const double a[], double r[]);

extern void VMSASINH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDASINH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsasinh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdasinh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAsinh (const int n, const float a[], float r[], long long int mode);
extern void vmdAsinh (const int n, const double a[], double r[], long long int mode);


extern void VCASINH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZASINH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcasinh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzasinh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAsinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAsinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCASINH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZASINH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcasinh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzasinh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAsinh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAsinh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSATANH_ (const int *n, const float a[], float r[]);
extern void VDATANH_ (const int *n, const double a[], double r[]);
extern void vsatanh_ (const int *n, const float a[], float r[]);
extern void vdatanh_ (const int *n, const double a[], double r[]);
extern void vsAtanh (const int n, const float a[], float r[]);
extern void vdAtanh (const int n, const double a[], double r[]);

extern void VMSATANH_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDATANH_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsatanh_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdatanh_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsAtanh (const int n, const float a[], float r[], long long int mode);
extern void vmdAtanh (const int n, const double a[], double r[], long long int mode);


extern void VCATANH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZATANH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcatanh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzatanh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcAtanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzAtanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCATANH_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZATANH_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcatanh_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzatanh_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcAtanh (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzAtanh (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VSERF_ (const int *n, const float a[], float r[]);
extern void VDERF_ (const int *n, const double a[], double r[]);
extern void vserf_ (const int *n, const float a[], float r[]);
extern void vderf_ (const int *n, const double a[], double r[]);
extern void vsErf (const int n, const float a[], float r[]);
extern void vdErf (const int n, const double a[], double r[]);

extern void VMSERF_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDERF_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmserf_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmderf_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsErf (const int n, const float a[], float r[], long long int mode);
extern void vmdErf (const int n, const double a[], double r[], long long int mode);


extern void VSERFINV_ (const int *n, const float a[], float r[]);
extern void VDERFINV_ (const int *n, const double a[], double r[]);
extern void vserfinv_ (const int *n, const float a[], float r[]);
extern void vderfinv_ (const int *n, const double a[], double r[]);
extern void vsErfInv (const int n, const float a[], float r[]);
extern void vdErfInv (const int n, const double a[], double r[]);

extern void VMSERFINV_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDERFINV_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmserfinv_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmderfinv_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsErfInv (const int n, const float a[], float r[], long long int mode);
extern void vmdErfInv (const int n, const double a[], double r[], long long int mode);


extern void VSHYPOT_ (const int *n, const float a[], const float b[], float r[]);
extern void VDHYPOT_ (const int *n, const double a[], const double b[], double r[]);
extern void vshypot_ (const int *n, const float a[], const float b[], float r[]);
extern void vdhypot_ (const int *n, const double a[], const double b[], double r[]);
extern void vsHypot (const int n, const float a[], const float b[], float r[]);
extern void vdHypot (const int n, const double a[], const double b[], double r[]);

extern void VMSHYPOT_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDHYPOT_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmshypot_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdhypot_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsHypot (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdHypot (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VSERFC_ (const int *n, const float a[], float r[]);
extern void VDERFC_ (const int *n, const double a[], double r[]);
extern void vserfc_ (const int *n, const float a[], float r[]);
extern void vderfc_ (const int *n, const double a[], double r[]);
extern void vsErfc (const int n, const float a[], float r[]);
extern void vdErfc (const int n, const double a[], double r[]);

extern void VMSERFC_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDERFC_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmserfc_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmderfc_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsErfc (const int n, const float a[], float r[], long long int mode);
extern void vmdErfc (const int n, const double a[], double r[], long long int mode);


extern void VSERFCINV_ (const int *n, const float a[], float r[]);
extern void VDERFCINV_ (const int *n, const double a[], double r[]);
extern void vserfcinv_ (const int *n, const float a[], float r[]);
extern void vderfcinv_ (const int *n, const double a[], double r[]);
extern void vsErfcInv (const int n, const float a[], float r[]);
extern void vdErfcInv (const int n, const double a[], double r[]);

extern void VMSERFCINV_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDERFCINV_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmserfcinv_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmderfcinv_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsErfcInv (const int n, const float a[], float r[], long long int mode);
extern void vmdErfcInv (const int n, const double a[], double r[], long long int mode);


extern void VSCDFNORM_ (const int *n, const float a[], float r[]);
extern void VDCDFNORM_ (const int *n, const double a[], double r[]);
extern void vscdfnorm_ (const int *n, const float a[], float r[]);
extern void vdcdfnorm_ (const int *n, const double a[], double r[]);
extern void vsCdfNorm (const int n, const float a[], float r[]);
extern void vdCdfNorm (const int n, const double a[], double r[]);

extern void VMSCDFNORM_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCDFNORM_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmscdfnorm_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdcdfnorm_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCdfNorm (const int n, const float a[], float r[], long long int mode);
extern void vmdCdfNorm (const int n, const double a[], double r[], long long int mode);


extern void VSCDFNORMINV_ (const int *n, const float a[], float r[]);
extern void VDCDFNORMINV_ (const int *n, const double a[], double r[]);
extern void vscdfnorminv_ (const int *n, const float a[], float r[]);
extern void vdcdfnorminv_ (const int *n, const double a[], double r[]);
extern void vsCdfNormInv (const int n, const float a[], float r[]);
extern void vdCdfNormInv (const int n, const double a[], double r[]);

extern void VMSCDFNORMINV_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCDFNORMINV_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmscdfnorminv_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdcdfnorminv_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCdfNormInv (const int n, const float a[], float r[], long long int mode);
extern void vmdCdfNormInv (const int n, const double a[], double r[], long long int mode);


extern void VSLGAMMA_ (const int *n, const float a[], float r[]);
extern void VDLGAMMA_ (const int *n, const double a[], double r[]);
extern void vslgamma_ (const int *n, const float a[], float r[]);
extern void vdlgamma_ (const int *n, const double a[], double r[]);
extern void vsLGamma (const int n, const float a[], float r[]);
extern void vdLGamma (const int n, const double a[], double r[]);

extern void VMSLGAMMA_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDLGAMMA_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmslgamma_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdlgamma_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsLGamma (const int n, const float a[], float r[], long long int mode);
extern void vmdLGamma (const int n, const double a[], double r[], long long int mode);


extern void VSTGAMMA_ (const int *n, const float a[], float r[]);
extern void VDTGAMMA_ (const int *n, const double a[], double r[]);
extern void vstgamma_ (const int *n, const float a[], float r[]);
extern void vdtgamma_ (const int *n, const double a[], double r[]);
extern void vsTGamma (const int n, const float a[], float r[]);
extern void vdTGamma (const int n, const double a[], double r[]);

extern void VMSTGAMMA_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDTGAMMA_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmstgamma_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdtgamma_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsTGamma (const int n, const float a[], float r[], long long int mode);
extern void vmdTGamma (const int n, const double a[], double r[], long long int mode);


extern void VSATAN2_ (const int *n, const float a[], const float b[], float r[]);
extern void VDATAN2_ (const int *n, const double a[], const double b[], double r[]);
extern void vsatan2_ (const int *n, const float a[], const float b[], float r[]);
extern void vdatan2_ (const int *n, const double a[], const double b[], double r[]);
extern void vsAtan2 (const int n, const float a[], const float b[], float r[]);
extern void vdAtan2 (const int n, const double a[], const double b[], double r[]);

extern void VMSATAN2_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDATAN2_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsatan2_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdatan2_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsAtan2 (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdAtan2 (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VSMUL_ (const int *n, const float a[], const float b[], float r[]);
extern void VDMUL_ (const int *n, const double a[], const double b[], double r[]);
extern void vsmul_ (const int *n, const float a[], const float b[], float r[]);
extern void vdmul_ (const int *n, const double a[], const double b[], double r[]);
extern void vsMul (const int n, const float a[], const float b[], float r[]);
extern void vdMul (const int n, const double a[], const double b[], double r[]);

extern void VMSMUL_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDMUL_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsmul_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdmul_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsMul (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdMul (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VCMUL_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZMUL_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcmul_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzmul_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcMul (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzMul (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCMUL_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZMUL_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcmul_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzmul_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcMul (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzMul (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VSDIV_ (const int *n, const float a[], const float b[], float r[]);
extern void VDDIV_ (const int *n, const double a[], const double b[], double r[]);
extern void vsdiv_ (const int *n, const float a[], const float b[], float r[]);
extern void vddiv_ (const int *n, const double a[], const double b[], double r[]);
extern void vsDiv (const int n, const float a[], const float b[], float r[]);
extern void vdDiv (const int n, const double a[], const double b[], double r[]);

extern void VMSDIV_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDDIV_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsdiv_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmddiv_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsDiv (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdDiv (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VCDIV_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZDIV_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcdiv_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzdiv_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcDiv (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzDiv (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCDIV_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZDIV_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcdiv_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzdiv_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcDiv (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzDiv (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VSPOW_ (const int *n, const float a[], const float b[], float r[]);
extern void VDPOW_ (const int *n, const double a[], const double b[], double r[]);
extern void vspow_ (const int *n, const float a[], const float b[], float r[]);
extern void vdpow_ (const int *n, const double a[], const double b[], double r[]);
extern void vsPow (const int n, const float a[], const float b[], float r[]);
extern void vdPow (const int n, const double a[], const double b[], double r[]);

extern void VMSPOW_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void VMDPOW_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmspow_ (const int *n, const float a[], const float b[], float r[], long long int *mode);
extern void vmdpow_ (const int *n, const double a[], const double b[], double r[], long long int *mode);
extern void vmsPow (const int n, const float a[], const float b[], float r[], long long int mode);
extern void vmdPow (const int n, const double a[], const double b[], double r[], long long int mode);


extern void VCPOW_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZPOW_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcpow_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzpow_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcPow (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzPow (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCPOW_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZPOW_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcpow_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzpow_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcPow (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzPow (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VSPOW3O2_ (const int *n, const float a[], float r[]);
extern void VDPOW3O2_ (const int *n, const double a[], double r[]);
extern void vspow3o2_ (const int *n, const float a[], float r[]);
extern void vdpow3o2_ (const int *n, const double a[], double r[]);
extern void vsPow3o2 (const int n, const float a[], float r[]);
extern void vdPow3o2 (const int n, const double a[], double r[]);

extern void VMSPOW3O2_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDPOW3O2_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmspow3o2_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdpow3o2_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsPow3o2 (const int n, const float a[], float r[], long long int mode);
extern void vmdPow3o2 (const int n, const double a[], double r[], long long int mode);


extern void VSPOW2O3_ (const int *n, const float a[], float r[]);
extern void VDPOW2O3_ (const int *n, const double a[], double r[]);
extern void vspow2o3_ (const int *n, const float a[], float r[]);
extern void vdpow2o3_ (const int *n, const double a[], double r[]);
extern void vsPow2o3 (const int n, const float a[], float r[]);
extern void vdPow2o3 (const int n, const double a[], double r[]);

extern void VMSPOW2O3_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDPOW2O3_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmspow2o3_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdpow2o3_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsPow2o3 (const int n, const float a[], float r[], long long int mode);
extern void vmdPow2o3 (const int n, const double a[], double r[], long long int mode);


extern void VSPOWX_ (const int *n, const float a[], const float *b, float r[]);
extern void VDPOWX_ (const int *n, const double a[], const double *b, double r[]);
extern void vspowx_ (const int *n, const float a[], const float *b, float r[]);
extern void vdpowx_ (const int *n, const double a[], const double *b, double r[]);
extern void vsPowx (const int n, const float a[], const float b, float r[]);
extern void vdPowx (const int n, const double a[], const double b, double r[]);

extern void VMSPOWX_ (const int *n, const float a[], const float *b, float r[], long long int *mode);
extern void VMDPOWX_ (const int *n, const double a[], const double *b, double r[], long long int *mode);
extern void vmspowx_ (const int *n, const float a[], const float *b, float r[], long long int *mode);
extern void vmdpowx_ (const int *n, const double a[], const double *b, double r[], long long int *mode);
extern void vmsPowx (const int n, const float a[], const float b, float r[], long long int mode);
extern void vmdPowx (const int n, const double a[], const double b, double r[], long long int mode);


extern void VCPOWX_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[]);
extern void VZPOWX_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[]);
extern void vcpowx_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[]);
extern void vzpowx_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[]);
extern void vcPowx (const int n, const MKL_Complex8 a[], const MKL_Complex8 b, MKL_Complex8 r[]);
extern void vzPowx (const int n, const MKL_Complex16 a[], const MKL_Complex16 b, MKL_Complex16 r[]);

extern void VMCPOWX_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[], long long int *mode);
extern void VMZPOWX_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[], long long int *mode);
extern void vmcpowx_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 *b, MKL_Complex8 r[], long long int *mode);
extern void vmzpowx_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 *b, MKL_Complex16 r[], long long int *mode);
extern void vmcPowx (const int n, const MKL_Complex8 a[], const MKL_Complex8 b, MKL_Complex8 r[], long long int mode);
extern void vmzPowx (const int n, const MKL_Complex16 a[], const MKL_Complex16 b, MKL_Complex16 r[], long long int mode);


extern void VSSINCOS_ (const int *n, const float a[], float r1[], float r2[]);
extern void VDSINCOS_ (const int *n, const double a[], double r1[], double r2[]);
extern void vssincos_ (const int *n, const float a[], float r1[], float r2[]);
extern void vdsincos_ (const int *n, const double a[], double r1[], double r2[]);
extern void vsSinCos (const int n, const float a[], float r1[], float r2[]);
extern void vdSinCos (const int n, const double a[], double r1[], double r2[]);

extern void VMSSINCOS_ (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void VMDSINCOS_ (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void vmssincos_ (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void vmdsincos_ (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void vmsSinCos (const int n, const float a[], float r1[], float r2[], long long int mode);
extern void vmdSinCos (const int n, const double a[], double r1[], double r2[], long long int mode);


extern void VSLINEARFRAC_ (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[]);
extern void VDLINEARFRAC_ (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[]);
extern void vslinearfrac_ (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[]);
extern void vdlinearfrac_ (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[]);
extern void vsLinearFrac (const int n, const float a[], const float b[], const float scalea, const float shifta, const float scaleb, const float shiftb, float r[]);
extern void vdLinearFrac (const int n, const double a[], const double b[], const double scalea, const double shifta, const double scaleb, const double shiftb, double r[]);

extern void VMSLINEARFRAC_ (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[], long long int *mode);
extern void VMDLINEARFRAC_ (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[], long long int *mode);
extern void vmslinearfrac_ (const int *n, const float a[], const float b[], const float *scalea, const float *shifta, const float *scaleb, const float *shiftb, float r[], long long int *mode);
extern void vmdlinearfrac_ (const int *n, const double a[], const double b[], const double *scalea, const double *shifta, const double *scaleb, const double *shiftb, double r[], long long int *mode);
extern void vmsLinearFrac (const int n, const float a[], const float b[], const float scalea, const float shifta, const float scaleb, const float shiftb, float r[], long long int mode);
extern void vmdLinearFrac (const int n, const double a[], const double b[], const double scalea, const double shifta, const double scaleb, const double shiftb, double r[], long long int mode);


extern void VSCEIL_ (const int *n, const float a[], float r[]);
extern void VDCEIL_ (const int *n, const double a[], double r[]);
extern void vsceil_ (const int *n, const float a[], float r[]);
extern void vdceil_ (const int *n, const double a[], double r[]);
extern void vsCeil (const int n, const float a[], float r[]);
extern void vdCeil (const int n, const double a[], double r[]);

extern void VMSCEIL_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDCEIL_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsceil_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdceil_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsCeil (const int n, const float a[], float r[], long long int mode);
extern void vmdCeil (const int n, const double a[], double r[], long long int mode);


extern void VSFLOOR_ (const int *n, const float a[], float r[]);
extern void VDFLOOR_ (const int *n, const double a[], double r[]);
extern void vsfloor_ (const int *n, const float a[], float r[]);
extern void vdfloor_ (const int *n, const double a[], double r[]);
extern void vsFloor (const int n, const float a[], float r[]);
extern void vdFloor (const int n, const double a[], double r[]);

extern void VMSFLOOR_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDFLOOR_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsfloor_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdfloor_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsFloor (const int n, const float a[], float r[], long long int mode);
extern void vmdFloor (const int n, const double a[], double r[], long long int mode);


extern void VSFRAC_ (const int *n, const float a[], float r[]);
extern void VDFRAC_ (const int *n, const double a[], double r[]);
extern void vsfrac_ (const int *n, const float a[], float r[]);
extern void vdfrac_ (const int *n, const double a[], double r[]);
extern void vsFrac (const int n, const float a[], float r[]);
extern void vdFrac (const int n, const double a[], double r[]);

extern void VMSFRAC_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDFRAC_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsfrac_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdfrac_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsFrac (const int n, const float a[], float r[], long long int mode);
extern void vmdFrac (const int n, const double a[], double r[], long long int mode);


extern void VSMODF_ (const int *n, const float a[], float r1[], float r2[]);
extern void VDMODF_ (const int *n, const double a[], double r1[], double r2[]);
extern void vsmodf_ (const int *n, const float a[], float r1[], float r2[]);
extern void vdmodf_ (const int *n, const double a[], double r1[], double r2[]);
extern void vsModf (const int n, const float a[], float r1[], float r2[]);
extern void vdModf (const int n, const double a[], double r1[], double r2[]);

extern void VMSMODF_ (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void VMDMODF_ (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void vmsmodf_ (const int *n, const float a[], float r1[], float r2[], long long int *mode);
extern void vmdmodf_ (const int *n, const double a[], double r1[], double r2[], long long int *mode);
extern void vmsModf (const int n, const float a[], float r1[], float r2[], long long int mode);
extern void vmdModf (const int n, const double a[], double r1[], double r2[], long long int mode);


extern void VSNEARBYINT_ (const int *n, const float a[], float r[]);
extern void VDNEARBYINT_ (const int *n, const double a[], double r[]);
extern void vsnearbyint_ (const int *n, const float a[], float r[]);
extern void vdnearbyint_ (const int *n, const double a[], double r[]);
extern void vsNearbyInt (const int n, const float a[], float r[]);
extern void vdNearbyInt (const int n, const double a[], double r[]);

extern void VMSNEARBYINT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDNEARBYINT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsnearbyint_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdnearbyint_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsNearbyInt (const int n, const float a[], float r[], long long int mode);
extern void vmdNearbyInt (const int n, const double a[], double r[], long long int mode);


extern void VSRINT_ (const int *n, const float a[], float r[]);
extern void VDRINT_ (const int *n, const double a[], double r[]);
extern void vsrint_ (const int *n, const float a[], float r[]);
extern void vdrint_ (const int *n, const double a[], double r[]);
extern void vsRint (const int n, const float a[], float r[]);
extern void vdRint (const int n, const double a[], double r[]);

extern void VMSRINT_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDRINT_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsrint_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdrint_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsRint (const int n, const float a[], float r[], long long int mode);
extern void vmdRint (const int n, const double a[], double r[], long long int mode);


extern void VSROUND_ (const int *n, const float a[], float r[]);
extern void VDROUND_ (const int *n, const double a[], double r[]);
extern void vsround_ (const int *n, const float a[], float r[]);
extern void vdround_ (const int *n, const double a[], double r[]);
extern void vsRound (const int n, const float a[], float r[]);
extern void vdRound (const int n, const double a[], double r[]);

extern void VMSROUND_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDROUND_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsround_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdround_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsRound (const int n, const float a[], float r[], long long int mode);
extern void vmdRound (const int n, const double a[], double r[], long long int mode);


extern void VSTRUNC_ (const int *n, const float a[], float r[]);
extern void VDTRUNC_ (const int *n, const double a[], double r[]);
extern void vstrunc_ (const int *n, const float a[], float r[]);
extern void vdtrunc_ (const int *n, const double a[], double r[]);
extern void vsTrunc (const int n, const float a[], float r[]);
extern void vdTrunc (const int n, const double a[], double r[]);

extern void VMSTRUNC_ (const int *n, const float a[], float r[], long long int *mode);
extern void VMDTRUNC_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmstrunc_ (const int *n, const float a[], float r[], long long int *mode);
extern void vmdtrunc_ (const int *n, const double a[], double r[], long long int *mode);
extern void vmsTrunc (const int n, const float a[], float r[], long long int mode);
extern void vmdTrunc (const int n, const double a[], double r[], long long int mode);


extern void VCCONJ_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void VZCONJ_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcconj_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzconj_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[]);
extern void vcConj (const int n, const MKL_Complex8 a[], MKL_Complex8 r[]);
extern void vzConj (const int n, const MKL_Complex16 a[], MKL_Complex16 r[]);

extern void VMCCONJ_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void VMZCONJ_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcconj_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int *mode);
extern void vmzconj_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int *mode);
extern void vmcConj (const int n, const MKL_Complex8 a[], MKL_Complex8 r[], long long int mode);
extern void vmzConj (const int n, const MKL_Complex16 a[], MKL_Complex16 r[], long long int mode);


extern void VCMULBYCONJ_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void VZMULBYCONJ_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcmulbyconj_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzmulbyconj_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);
extern void vcMulByConj (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[]);
extern void vzMulByConj (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[]);

extern void VMCMULBYCONJ_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void VMZMULBYCONJ_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcmulbyconj_ (const int *n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int *mode);
extern void vmzmulbyconj_ (const int *n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int *mode);
extern void vmcMulByConj (const int n, const MKL_Complex8 a[], const MKL_Complex8 b[], MKL_Complex8 r[], long long int mode);
extern void vmzMulByConj (const int n, const MKL_Complex16 a[], const MKL_Complex16 b[], MKL_Complex16 r[], long long int mode);


extern void VCCIS_ (const int *n, const float a[], MKL_Complex8 r[]);
extern void VZCIS_ (const int *n, const double a[], MKL_Complex16 r[]);
extern void vccis_ (const int *n, const float a[], MKL_Complex8 r[]);
extern void vzcis_ (const int *n, const double a[], MKL_Complex16 r[]);
extern void vcCIS (const int n, const float a[], MKL_Complex8 r[]);
extern void vzCIS (const int n, const double a[], MKL_Complex16 r[]);

extern void VMCCIS_ (const int *n, const float a[], MKL_Complex8 r[], long long int *mode);
extern void VMZCIS_ (const int *n, const double a[], MKL_Complex16 r[], long long int *mode);
extern void vmccis_ (const int *n, const float a[], MKL_Complex8 r[], long long int *mode);
extern void vmzcis_ (const int *n, const double a[], MKL_Complex16 r[], long long int *mode);
extern void vmcCIS (const int n, const float a[], MKL_Complex8 r[], long long int mode);
extern void vmzCIS (const int n, const double a[], MKL_Complex16 r[], long long int mode);







extern void VSPACKI_ (const int *n, const float a[], const int * incra, float y[]);
extern void VDPACKI_ (const int *n, const double a[], const int * incra, double y[]);
extern void vspacki_ (const int *n, const float a[], const int * incra, float y[]);
extern void vdpacki_ (const int *n, const double a[], const int * incra, double y[]);
extern void vsPackI (const int n, const float a[], const int incra, float y[]);
extern void vdPackI (const int n, const double a[], const int incra, double y[]);

extern void VCPACKI_ (const int *n, const MKL_Complex8 a[], const int * incra, MKL_Complex8 y[]);
extern void VZPACKI_ (const int *n, const MKL_Complex16 a[], const int * incra, MKL_Complex16 y[]);
extern void vcpacki_ (const int *n, const MKL_Complex8 a[], const int * incra, MKL_Complex8 y[]);
extern void vzpacki_ (const int *n, const MKL_Complex16 a[], const int * incra, MKL_Complex16 y[]);
extern void vcPackI (const int n, const MKL_Complex8 a[], const int incra, MKL_Complex8 y[]);
extern void vzPackI (const int n, const MKL_Complex16 a[], const int incra, MKL_Complex16 y[]);


extern void VSPACKV_ (const int *n, const float a[], const int ia[], float y[]);
extern void VDPACKV_ (const int *n, const double a[], const int ia[], double y[]);
extern void vspackv_ (const int *n, const float a[], const int ia[], float y[]);
extern void vdpackv_ (const int *n, const double a[], const int ia[], double y[]);
extern void vsPackV (const int n, const float a[], const int ia[], float y[]);
extern void vdPackV (const int n, const double a[], const int ia[], double y[]);

extern void VCPACKV_ (const int *n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void VZPACKV_ (const int *n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);
extern void vcpackv_ (const int *n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void vzpackv_ (const int *n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);
extern void vcPackV (const int n, const MKL_Complex8 a[], const int ia[], MKL_Complex8 y[]);
extern void vzPackV (const int n, const MKL_Complex16 a[], const int ia[], MKL_Complex16 y[]);


extern void VSPACKM_ (const int *n, const float a[], const int ma[], float y[]);
extern void VDPACKM_ (const int *n, const double a[], const int ma[], double y[]);
extern void vspackm_ (const int *n, const float a[], const int ma[], float y[]);
extern void vdpackm_ (const int *n, const double a[], const int ma[], double y[]);
extern void vsPackM (const int n, const float a[], const int ma[], float y[]);
extern void vdPackM (const int n, const double a[], const int ma[], double y[]);

extern void VCPACKM_ (const int *n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void VZPACKM_ (const int *n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);
extern void vcpackm_ (const int *n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void vzpackm_ (const int *n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);
extern void vcPackM (const int n, const MKL_Complex8 a[], const int ma[], MKL_Complex8 y[]);
extern void vzPackM (const int n, const MKL_Complex16 a[], const int ma[], MKL_Complex16 y[]);







extern void VSUNPACKI_ (const int *n, const float a[], float y[], const int * incry);
extern void VDUNPACKI_ (const int *n, const double a[], double y[], const int * incry);
extern void vsunpacki_ (const int *n, const float a[], float y[], const int * incry);
extern void vdunpacki_ (const int *n, const double a[], double y[], const int * incry);
extern void vsUnpackI (const int n, const float a[], float y[], const int incry );
extern void vdUnpackI (const int n, const double a[], double y[], const int incry );

extern void VCUNPACKI_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int * incry);
extern void VZUNPACKI_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int * incry);
extern void vcunpacki_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int * incry);
extern void vzunpacki_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int * incry);
extern void vcUnpackI (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int incry );
extern void vzUnpackI (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int incry );


extern void VSUNPACKV_ (const int *n, const float a[], float y[], const int iy[] );
extern void VDUNPACKV_ (const int *n, const double a[], double y[], const int iy[] );
extern void vsunpackv_ (const int *n, const float a[], float y[], const int iy[] );
extern void vdunpackv_ (const int *n, const double a[], double y[], const int iy[] );
extern void vsUnpackV (const int n, const float a[], float y[], const int iy[] );
extern void vdUnpackV (const int n, const double a[], double y[], const int iy[] );

extern void VCUNPACKV_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void VZUNPACKV_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);
extern void vcunpackv_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void vzunpackv_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);
extern void vcUnpackV (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int iy[]);
extern void vzUnpackV (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int iy[]);


extern void VSUNPACKM_ (const int *n, const float a[], float y[], const int my[] );
extern void VDUNPACKM_ (const int *n, const double a[], double y[], const int my[] );
extern void vsunpackm_ (const int *n, const float a[], float y[], const int my[] );
extern void vdunpackm_ (const int *n, const double a[], double y[], const int my[] );
extern void vsUnpackM (const int n, const float a[], float y[], const int my[] );
extern void vdUnpackM (const int n, const double a[], double y[], const int my[] );

extern void VCUNPACKM_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void VZUNPACKM_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);
extern void vcunpackm_ (const int *n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void vzunpackm_ (const int *n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);
extern void vcUnpackM (const int n, const MKL_Complex8 a[], MKL_Complex8 y[], const int my[]);
extern void vzUnpackM (const int n, const MKL_Complex16 a[], MKL_Complex16 y[], const int my[]);
extern int VMLSETERRSTATUS_ (const int * status);
extern int vmlseterrstatus_ (const int * status);
extern int vmlSetErrStatus (const int status);


extern int VMLGETERRSTATUS_ (void);
extern int vmlgeterrstatus_ (void);
extern int vmlGetErrStatus (void);


extern int VMLCLEARERRSTATUS_ (void);
extern int vmlclearerrstatus_ (void);
extern int vmlClearErrStatus (void);


extern VMLErrorCallBack VMLSETERRORCALLBACK_ (const VMLErrorCallBack func);
extern VMLErrorCallBack vmlseterrorcallback_ (const VMLErrorCallBack func);
extern VMLErrorCallBack vmlSetErrorCallBack (const VMLErrorCallBack func);


extern VMLErrorCallBack VMLGETERRORCALLBACK_ (void);
extern VMLErrorCallBack vmlgeterrorcallback_ (void);
extern VMLErrorCallBack vmlGetErrorCallBack (void);


extern VMLErrorCallBack VMLCLEARERRORCALLBACK_ (void);
extern VMLErrorCallBack vmlclearerrorcallback_ (void);
extern VMLErrorCallBack vmlClearErrorCallBack (void);
extern unsigned int VMLSETMODE_ (const unsigned int *newmode);
extern unsigned int vmlsetmode_ (const unsigned int *newmode);
extern unsigned int vmlSetMode (const unsigned int newmode);


extern unsigned int VMLGETMODE_ (void);
extern unsigned int vmlgetmode_ (void);
extern unsigned int vmlGetMode (void);

